import numpy as np
from scipy.integrate import simps
from numpy import trapz
import os, sys

try:
	import pyext
except:
	print "ERROR: This script must be loaded by the PD/Max pyext external"


def sndarea(mfcclist):
    area = abs(trapz(mfcclist, dx=3))
    return area

class spaceArea(pyext._class):
    _inlets=4
    _outlets=2

    def __init__(self):
        self.mfcclist = []
        self.vol = 0
        self.l_vol = []

#recieving multiple mfcc vectors, applying Simpson rule
#adding to make volume
#for each sound
    def list_2(self,*st):
        self.mfcclist = st
        area = sndarea(self.mfcclist)
        ##print area
        self.vol = self.vol + area
        ##print self.vol

#adding the sounds volume to a list        
    def bang_1(self):
        self.l_vol.append(self.vol)
        print self.l_vol
        self._outlet(1,self.l_vol)
        self.vol = 0

#calculating portions of sound volumes
    def bang_3(self):
        portion = []
        print self.l_vol
        total = 0
        for item in self.l_vol:
                total = item + total
        print total
        for item in self.l_vol:
#               self._outlet(4,(self.d_area[key]/total))
                 portion.append(item/total)
        print portion
        self._outlet(2,portion)

#reset
    def bang_4(self):
        self.mfcclist = []
        self.l_vol = []
        self.vol = 0
